#include <iostream>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include "Infrastructure.h"

using namespace std;
C_PACKET *Routing_Scheme1(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car){
    C_PACKET *Pre_Packet, *Next_Packet;

    //Sure to Transmit
    Pre_Packet = Find_Pre(ip->PACKET_BUFFER, Packet->ID);
    Next_Packet = Packet->Next_PACKET;
    if(ip->PACKET_BUFFER == Packet){
        ip->PACKET_BUFFER = Next_Packet;
        Packet->Next_PACKET = NULL;
        Car->NextPacket = insert_node(Car->NextPacket, Packet);
        cout << "1 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
        return ip->PACKET_BUFFER;
    }//Head
    else if(Next_Packet == NULL){
        Pre_Packet->Next_PACKET = NULL;
        Packet->Next_PACKET = NULL;
        Car->NextPacket = insert_node(Car->NextPacket, Packet);
        cout << "2 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
        return NULL;
    }//Tail
    else{
        Pre_Packet->Next_PACKET = Next_Packet;
        Packet->Next_PACKET = NULL;
        Car->NextPacket = insert_node(Car->NextPacket, Packet);
        cout << "3 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
        return Next_Packet;
    }// Middle
}
C_PACKET *Routing_Scheme2(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car){
    char filename[]="Pick_Car_Amount.txt";
    fstream fp;
    fp.open(filename, ios::out|ios::app);

    C_PACKET *Pre_Packet, *Next_Packet;
    static int Pick_Amount = 0;
    if(Packet->Pass_Time + Packet->Travel_Time >= (Packet->TTL - 605*2)){
        Pick_Amount++;
        fp << "Pick Amount : " << Pick_Amount << endl;
    //Sure to Transmit
        Pre_Packet = Find_Pre(ip->PACKET_BUFFER, Packet->ID);
        Next_Packet = Packet->Next_PACKET;
        if(ip->PACKET_BUFFER == Packet){
            ip->PACKET_BUFFER = Next_Packet;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "1 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return ip->PACKET_BUFFER;
        }//Head
        else if(Next_Packet == NULL){
            Pre_Packet->Next_PACKET = NULL;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "2 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return NULL;
        }//Tail
        else{
            Pre_Packet->Next_PACKET = Next_Packet;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "3 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return Next_Packet;
        }// Middle
    }
    else return Packet;
}
C_PACKET *Routing_Scheme3(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car){
    char filename[]="Pick_Car_Amount.txt";
    fstream fp;
    fp.open(filename, ios::out|ios::app);
    C_PACKET *Pre_Packet, *Next_Packet;
    static int Pick_Amount = 0;
    int Remain_Time = Packet->TTL - (Packet->Travel_Time + Packet->Pass_Time);
    float t;
    float lumda;
    lumda = 1/605.0;
    t = lumda/2.0;
    float probability = exp((exp(t) - 1)*lumda - t*Remain_Time);
    if(probability >= 0.6){
        Pick_Amount++;
        fp << "Pick Amount : " << Pick_Amount << endl;
    //Sure to Transmit
        Pre_Packet = Find_Pre(ip->PACKET_BUFFER, Packet->ID);
        Next_Packet = Packet->Next_PACKET;
        if(ip->PACKET_BUFFER == Packet){
            ip->PACKET_BUFFER = Next_Packet;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "1 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return ip->PACKET_BUFFER;
        }//Head
        else if(Next_Packet == NULL){
            Pre_Packet->Next_PACKET = NULL;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "2 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return NULL;
        }//Tail
        else{
            Pre_Packet->Next_PACKET = Next_Packet;
            Packet->Next_PACKET = NULL;
            Car->NextPacket = insert_node(Car->NextPacket, Packet);
            cout << "3 Packet " << Packet->ID << " has sent to Car " <<  Car->ID << endl;
            return Next_Packet;
        }// Middle
    }
    else return Packet;
}
int Set_Car_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length, int Success){
    int i,j;
    C_INFRASTRUCTURE *tempItr;
    C_PACKET *tempPtr, *nextPtr;
    C_NODE *tempCtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            //up
            tempCtr = tempItr->Up_Car_Buffer;/////////////////////////////////////////////////
            while(tempCtr != NULL){
                tempPtr = tempCtr->NextPacket;
                while(tempPtr != NULL){
                    tempPtr->Pass_Time++;
                    if(tempPtr->Success == 1){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                        Success++;
                    }
                    else if(tempPtr->Pass_Time > tempPtr->TTL){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                    }
                    else{
                        tempPtr = tempPtr->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //down
            tempCtr = tempItr->Down_Car_Buffer;/////////////////////////////////////////////////
            while(tempCtr != NULL){
                tempPtr = tempCtr->NextPacket;
                while(tempPtr != NULL){
                    tempPtr->Pass_Time++;
                    if(tempPtr->Success == 1){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                        Success++;
                    }
                    else if(tempPtr->Pass_Time > tempPtr->TTL){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                    }
                    else{
                        tempPtr = tempPtr->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //left
            tempCtr = tempItr->Left_Car_Buffer;/////////////////////////////////////////////////
            while(tempCtr != NULL){
                tempPtr = tempCtr->NextPacket;
                while(tempPtr != NULL){
                    tempPtr->Pass_Time++;
                    if(tempPtr->Success == 1){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                        Success++;
                    }
                    else if(tempPtr->Pass_Time > tempPtr->TTL){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                    }
                    else{
                        tempPtr = tempPtr->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //right
            tempCtr = tempItr->Right_Car_Buffer;/////////////////////////////////////////////////
            while(tempCtr != NULL){
                tempPtr = tempCtr->NextPacket;
                while(tempPtr != NULL){
                    tempPtr->Pass_Time++;
                    if(tempPtr->Success == 1){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                        Success++;
                    }
                    else if(tempPtr->Pass_Time > tempPtr->TTL){
                        nextPtr = tempPtr->Next_PACKET;
                        tempCtr->NextPacket = delete_node(tempCtr->NextPacket, tempPtr->ID);
                        tempPtr = nextPtr;
                    }
                    else{
                        tempPtr = tempPtr->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
        }//width
    }//height
    return Success;
}
void Set_Infrastructure_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length){
    int i,j;
    C_INFRASTRUCTURE *tempItr;
    C_PACKET *tempPtr, *nextPtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            tempPtr = tempItr->PACKET_BUFFER;
            while(tempPtr != NULL){
                tempPtr->Pass_Time++;
                if(tempPtr->Pass_Time >= tempPtr->TTL){
                    nextPtr = tempPtr->Next_PACKET;
                    tempItr->PACKET_BUFFER = delete_node(tempItr->PACKET_BUFFER, tempPtr->ID);
                    tempPtr = nextPtr;
                }
                else{
                    tempPtr = tempPtr->Next_PACKET;
                }
            }
        }
    }
}
void Refresh_Infrastructure_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length){
    C_INFRASTRUCTURE *tempItr;
    C_NODE *tempCtr;
    C_PACKET *Inf_Packet, *temp_Packet;
    int i,j,Valid_Car,flag;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            Inf_Packet = tempItr->PACKET_BUFFER;
            while(Inf_Packet != NULL){
                temp_Packet = Inf_Packet;
                flag = 0;
                //up
                tempCtr = tempItr->Up_Car_Buffer;
                while(tempCtr != NULL){
                    Valid_Car = 0;
                    if(tempItr->y - tempCtr->y <= tempItr->Transmission_Range){
                        Valid_Car = Check_Path(tempCtr->Path, Inf_Packet->Destination_X, Inf_Packet->Destination_Y);
                        if(Valid_Car == 1){
                            Inf_Packet = Routing_Scheme2(tempItr, Inf_Packet, tempCtr);
                        }//Trajectory contains Packet Destination
                    }//In transmission range
                    if(temp_Packet != Inf_Packet){
                            flag = 1;
                            break;
                    }
                    tempCtr = tempCtr->nextCar;
                }//Still have Car
                if(flag == 1)continue;
                //Left
                tempCtr = tempItr->Left_Car_Buffer;
                while(tempCtr != NULL){
                    Valid_Car = 0;
                    if(tempCtr->y - tempItr->y <= tempItr->Transmission_Range){
                        Valid_Car = Check_Path(tempCtr->Path, Inf_Packet->Destination_X, Inf_Packet->Destination_Y);
                        if(Valid_Car == 1){
                            Inf_Packet = Routing_Scheme2(tempItr, Inf_Packet, tempCtr);
                        }//Trajectory contains Packet Destination
                    }//In transmission range
                    if(temp_Packet != Inf_Packet){
                            flag = 1;
                            break;
                    }
                    tempCtr = tempCtr->nextCar;
                }//Still have Car
                if(flag == 1)continue;
                //Right
                tempCtr = tempItr->Right_Car_Buffer;
                while(tempCtr != NULL){
                    Valid_Car = 0;
                    if(tempItr->x - tempCtr->x <= tempItr->Transmission_Range){
                        Valid_Car = Check_Path(tempCtr->Path, Inf_Packet->Destination_X, Inf_Packet->Destination_Y);
                        if(Valid_Car == 1){
                            Inf_Packet = Routing_Scheme2(tempItr, Inf_Packet, tempCtr);
                        }//Trajectory contains Packet Destination
                    }//In transmission range
                    if(temp_Packet != Inf_Packet){
                            flag = 1;
                            break;
                    }
                    tempCtr = tempCtr->nextCar;
                }//Still have Car
                if(flag == 1)continue;
                //Down
                tempCtr = tempItr->Down_Car_Buffer;
                while(tempCtr != NULL){
                    Valid_Car = 0;
                    if(tempCtr->y - tempItr->y <= tempItr->Transmission_Range){
                        Valid_Car = Check_Path(tempCtr->Path, Inf_Packet->Destination_X, Inf_Packet->Destination_Y);
                        if(Valid_Car == 1){
                            Inf_Packet = Routing_Scheme2(tempItr, Inf_Packet, tempCtr);
                        }//Trajectory contains Packet Destination
                    }//In transmission range
                    if(temp_Packet != Inf_Packet){
                            flag = 1;
                            break;
                    }
                    tempCtr = tempCtr->nextCar;
                }//Still have Car
                if(flag == 1)continue;
                //Done
                if(flag != 1)Inf_Packet = Inf_Packet->Next_PACKET;
            }//Still have packet
        }//width
    }//height
}
void Refresh_Car_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length){
    int i,j;
    C_INFRASTRUCTURE *tempItr;
    C_NODE *tempCtr;
    C_PACKET *Car_Packet;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            //Up
            tempCtr = tempItr->Up_Car_Buffer;
            while(tempCtr != NULL){
                if(abs(tempItr->y - tempCtr->y) <= tempItr->Transmission_Range){
                    Car_Packet = tempCtr->NextPacket;
                    while(Car_Packet != NULL){
                        if(Car_Packet->Destination_X == tempItr->x && Car_Packet->Destination_Y == tempItr->y && Car_Packet->Pass_Time <= Car_Packet->TTL){
                            Car_Packet->Success = 1;
                            cout << "==================================" << endl;
                            cout << "Car At " << tempCtr->x << " , " << tempCtr->y << endl;
                            cout << "Packet has Destination " << Car_Packet->Destination_X << " , " << Car_Packet->Destination_Y << endl;
                            cout << "==================================" << endl;
                        }
                        Car_Packet = Car_Packet->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //Down
            tempCtr = tempItr->Down_Car_Buffer;
            while(tempCtr != NULL){
                if(abs(tempItr->y - tempCtr->y) <= tempItr->Transmission_Range){
                    Car_Packet = tempCtr->NextPacket;
                    while(Car_Packet != NULL){
                        if(Car_Packet->Destination_X == tempItr->x && Car_Packet->Destination_Y == tempItr->y && Car_Packet->Pass_Time <= Car_Packet->TTL){
                            Car_Packet->Success = 1;
                            cout << "==================================" << endl;
                            cout << "Car At " << tempCtr->x << " , " << tempCtr->y << endl;
                            cout << "Packet has Destination " << Car_Packet->Destination_X << " , " << Car_Packet->Destination_Y << endl;
                            cout << "==================================" << endl;
                        }
                        Car_Packet = Car_Packet->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //Left
            tempCtr = tempItr->Left_Car_Buffer;
            while(tempCtr != NULL){
                if(abs(tempItr->x - tempCtr->x) <= tempItr->Transmission_Range){
                    Car_Packet = tempCtr->NextPacket;
                    while(Car_Packet != NULL){
                        if(Car_Packet->Destination_X == tempItr->x && Car_Packet->Destination_Y == tempItr->y && Car_Packet->Pass_Time <= Car_Packet->TTL){
                            Car_Packet->Success = 1;
                            cout << "==================================" << endl;
                            cout << "Car At " << tempCtr->x << " , " << tempCtr->y << endl;
                            cout << "Packet has Destination " << Car_Packet->Destination_X << " , " << Car_Packet->Destination_Y << endl;
                            cout << "==================================" << endl;
                        }
                        Car_Packet = Car_Packet->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //Right
            tempCtr = tempItr->Right_Car_Buffer;
            while(tempCtr != NULL){
                if(abs(tempItr->x - tempCtr->x) <= tempItr->Transmission_Range){
                    Car_Packet = tempCtr->NextPacket;
                    while(Car_Packet != NULL){
                        if(Car_Packet->Destination_X == tempItr->x && Car_Packet->Destination_Y == tempItr->y && Car_Packet->Pass_Time <= Car_Packet->TTL){
                            Car_Packet->Success = 1;
                            cout << "==================================" << endl;
                            cout << "Car At " << tempCtr->x << " , " << tempCtr->y << endl;
                            cout << "Packet has Destination " << Car_Packet->Destination_X << " , " << Car_Packet->Destination_Y << endl;
                            cout << "==================================" << endl;
                        }
                        Car_Packet = Car_Packet->Next_PACKET;
                    }
                }
                tempCtr = tempCtr->nextCar;
            }
            //Right end
        }
    }
}
void Create_Packet(C_INFRASTRUCTURE *ip, int Road_Length, int TTL, int bytes, int Height, int Width, int Speed){
    static int ID = 0;
    int x,y,dir;
    C_PACKET *tempPtr;
    tempPtr = (C_PACKET *)malloc(sizeof(C_PACKET));
    tempPtr->ID = ID;
    tempPtr->TTL = TTL;
    tempPtr->bytes = bytes;
    x = (rand()%(Width-2)+1);
    y = (rand()%(Height-2)+1);
    dir = rand()%4;
    switch(dir){
    case 0 :
        tempPtr->Destination_X = (x)*Road_Length;
        tempPtr->Destination_Y = (y+1)*Road_Length;
        break;
    case 1 :
        tempPtr->Destination_X = (x-1)*Road_Length;
        tempPtr->Destination_Y = (y)*Road_Length;
        break;
    case 2 :
        tempPtr->Destination_X = (x+1)*Road_Length;
        tempPtr->Destination_Y = (y)*Road_Length;
        break;
    case 3 :
        tempPtr->Destination_X = (x)*Road_Length;
        tempPtr->Destination_Y = (y-1)*Road_Length;
        break;
    }
    tempPtr->Source_X = x*Road_Length;
    tempPtr->Source_Y = y*Road_Length;
    tempPtr->Travel_Time = abs((tempPtr->Source_X) - (tempPtr->Destination_X))/Speed + abs((tempPtr->Source_Y) - (tempPtr->Destination_Y))/Speed;
    tempPtr->Pass_Time = 0;
    tempPtr->Next_PACKET = NULL;
    tempPtr->Success = 0;
    (ip+x+y*Width)->PACKET_BUFFER = insert_node((ip+x+y*Width)->PACKET_BUFFER, tempPtr);
    ID++;
}
int Check_Path(T_NODE *np, int Des_x, int Des_y){
    T_NODE *tempPtr;
    tempPtr = np;
    if(tempPtr==NULL)return 0;
    while(tempPtr != NULL){
        if(tempPtr->x == Des_x && tempPtr->y == Des_y)return 1;
        tempPtr = tempPtr->nextPtr;
    }
    return 0;
}
void DisPlay_All_Packet(C_INFRASTRUCTURE *ip, int height, int width){
    int i,j;
    C_INFRASTRUCTURE *tempItr;
    C_PACKET *tempPacket;
    C_NODE *tempCtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            tempPacket = tempItr->PACKET_BUFFER;
            while(tempPacket != NULL){
                cout << "Packet ID : " << tempPacket->ID << "   at Infrastrcture " << tempItr->x << " , " << tempItr->y << endl;
                cout << "Pass_Time : " << tempPacket->Pass_Time << "  TTL : " << tempPacket->TTL << endl;
                cout << "Travel_Time = " << tempPacket->Travel_Time << endl;
                cout << "Success : " << tempPacket->Success << endl;
                tempPacket = tempPacket->Next_PACKET;
            }
            //up
            tempCtr = tempItr->Up_Car_Buffer;
            while(tempCtr != NULL){
                tempPacket = tempCtr->NextPacket;
                while(tempPacket != NULL){
                    cout << "Packet ID : " << tempPacket->ID << "   At Vehicle " << tempCtr->ID << endl;
                    cout << "Pass_Time : " << tempPacket->Pass_Time << "  TTL : " << tempPacket->TTL << endl;
                    cout << "Travel_Time = " << tempPacket->Travel_Time << endl;
                    cout << "Success : " << tempPacket->Success << endl;
                    tempPacket = tempPacket->Next_PACKET;
                }
                tempCtr = tempCtr->nextCar;
            }
            //down
            tempCtr = tempItr->Down_Car_Buffer;
            while(tempCtr != NULL){
                tempPacket = tempCtr->NextPacket;
                while(tempPacket != NULL){
                    cout << "Packet ID : " << tempPacket->ID << "   At Vehicle " << tempCtr->ID << endl;
                    cout << "Pass_Time : " << tempPacket->Pass_Time << "  TTL : " << tempPacket->TTL << endl;
                    cout << "Travel_Time = " << tempPacket->Travel_Time << endl;
                    cout << "Success : " << tempPacket->Success << endl;
                    tempPacket = tempPacket->Next_PACKET;
                }
                tempCtr = tempCtr->nextCar;
            }
            //left
            tempCtr = tempItr->Left_Car_Buffer;
            while(tempCtr != NULL){
                tempPacket = tempCtr->NextPacket;
                while(tempPacket != NULL){
                    cout << "Packet ID : " << tempPacket->ID << "   At Vehicle " << tempCtr->ID << endl;
                    cout << "Pass_Time : " << tempPacket->Pass_Time << "  TTL : " << tempPacket->TTL << endl;
                    cout << "Travel_Time = " << tempPacket->Travel_Time << endl;
                    cout << "Success : " << tempPacket->Success << endl;
                    tempPacket = tempPacket->Next_PACKET;
                }
                tempCtr = tempCtr->nextCar;
            }
            //right
            tempCtr = tempItr->Right_Car_Buffer;
            while(tempCtr != NULL){
                tempPacket = tempCtr->NextPacket;
                while(tempPacket != NULL){
                    cout << "Packet ID : " << tempPacket->ID << "   At Vehicle " << tempCtr->ID << endl;
                    cout << "Pass_Time : " << tempPacket->Pass_Time << "  TTL : " << tempPacket->TTL << endl;
                    cout << "Travel_Time = " << tempPacket->Travel_Time << endl;
                    cout << "Success : " << tempPacket->Success << endl;
                    tempPacket = tempPacket->Next_PACKET;
                }
                tempCtr = tempCtr->nextCar;
            }
            //done
        }
    }
}


void Display_All_Vehicles_Trajectory(C_INFRASTRUCTURE *np, int height, int width){
    int i,j;
    C_NODE *tempPtr, *nextPtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempPtr = (np+i*width+j)->Up_Car_Buffer;
            while(tempPtr != NULL){
                cout << "CAR ID : " << tempPtr->ID << "     Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                cout << "Trajectory List" <<endl;
                dispList(tempPtr->Path);
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Down_Car_Buffer;
            while(tempPtr != NULL){
                cout << "CAR ID : " << tempPtr->ID << "     Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                cout << "Trajectory List" <<endl;
                dispList(tempPtr->Path);
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Left_Car_Buffer;
            while(tempPtr != NULL){
                cout << "CAR ID : " << tempPtr->ID << "     Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                cout << "Trajectory List" <<endl;
                dispList(tempPtr->Path);
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Right_Car_Buffer;
            while(tempPtr != NULL){
                cout << "CAR ID : " << tempPtr->ID << "     Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                cout << "Trajectory List" <<endl;
                dispList(tempPtr->Path);
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
        }
    }
}
int CAR_AMOUNT(C_INFRASTRUCTURE *np, int height, int width){
    int i,j;
    int AMOUNT = 0;
    C_NODE *tempPtr, *nextPtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempPtr = (np+i*width+j)->Up_Car_Buffer;
            while(tempPtr != NULL){
                AMOUNT++;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Down_Car_Buffer;
            while(tempPtr != NULL){
                AMOUNT++;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Left_Car_Buffer;
            while(tempPtr != NULL){
                AMOUNT++;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Right_Car_Buffer;
            while(tempPtr != NULL){
                AMOUNT++;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
        }
    }
    return AMOUNT;
}
void DisPlay_All_Car_With_ID(C_INFRASTRUCTURE *np, int height, int width, int T, int Traffic_Light_Period){
    char filename[]="All_Car_LOCATION_BASED_ID.txt";
    fstream fp;
    fp.open(filename, ios::out|ios::app);
    fp << "----CAR LIST----" << endl;
    fp << "~~~~~~~TIME = " << T << endl << endl;
    if(Traffic_Light_Period == 5)fp << "TRAFFIC LIGHT CHANGE !!!!" <<endl << endl;
    int i,j;
    C_NODE *tempPtr, *nextPtr;
    T_NODE *Destination;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempPtr = (np+i*width+j)->Up_Car_Buffer;
            while(tempPtr != NULL){
                Destination = last_node(tempPtr->Path);
                fp << endl << "CAR ID : " << tempPtr->ID << "    Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                fp << "Bounded in Intersection ( " << (np+i*width+j)->x << " , " << (np+i*width+j)->y << " )" << " Up_Car_Buffer" << endl;
                fp << "Traffic Light signal is " << (np+i*width+j)->Traffic_Light[0] << endl;
                fp << "Direction : " << tempPtr->Direction << " (0 : up , 1 : Left, 2 : Right, 3 : Down)"<< endl;
                fp << "Temp_Destination is " << tempPtr->Path->x << " , " << tempPtr->Path->y << "    ||   Destination is " << Destination->x << " , " << Destination->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
            }
            tempPtr = (np+i*width+j)->Down_Car_Buffer;
            while(tempPtr != NULL){
                Destination = last_node(tempPtr->Path);
                fp << endl << "CAR ID : " << tempPtr->ID << "    Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                fp << "Bounded in Intersection ( " << (np+i*width+j)->x << " , " << (np+i*width+j)->y << " )" << " Down_Car_Buffer" << endl;
                fp << "Traffic Light signal is " << (np+i*width+j)->Traffic_Light[0] << endl;
                fp << "Direction : " << tempPtr->Direction << " (0 : up , 1 : Left, 2 : Right, 3 : Down)"<< endl;
                fp << "Temp_Destination is " << tempPtr->Path->x << " , " << tempPtr->Path->y << "    ||   Destination is " << Destination->x << " , " << Destination->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
            }
            tempPtr = (np+i*width+j)->Left_Car_Buffer;
            while(tempPtr != NULL){
                Destination = last_node(tempPtr->Path);
                fp << endl << "CAR ID : " << tempPtr->ID << "    Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                fp << "Bounded in Intersection ( " << (np+i*width+j)->x << " , " << (np+i*width+j)->y << " )" << " Left_Car_Buffer" << endl;
                fp << "Traffic Light signal is " << (np+i*width+j)->Traffic_Light[1] << endl;
                fp << "Direction : " << tempPtr->Direction << " (0 : up , 1 : Left, 2 : Right, 3 : Down)"<< endl;
                fp << "Temp_Destination is " << tempPtr->Path->x << " , " << tempPtr->Path->y << "   ||   Destination is " << Destination->x << " , " << Destination->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
            }
            tempPtr = (np+i*width+j)->Right_Car_Buffer;
            while(tempPtr != NULL){
                Destination = last_node(tempPtr->Path);
                fp << endl << "CAR ID : " << tempPtr->ID << "    Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                fp << "Bounded in Intersection ( " << (np+i*width+j)->x << " , " << (np+i*width+j)->y << " )" << " Right_Car_Buffer" << endl;
                fp << "Traffic Light signal is " << (np+i*width+j)->Traffic_Light[1] << endl;
                fp << "Direction : " << tempPtr->Direction << " (0 : up , 1 : Left, 2 : Right, 3 : Down)"<< endl;
                fp << "Temp_Destination is " << tempPtr->Path->x << " , " << tempPtr->Path->y << "   ||   Destination is " << Destination->x << " , " << Destination->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
            }
        }
    }
}
void Set_Vehicle_Flag(C_INFRASTRUCTURE *np, int height, int width){
    int i,j;
    C_NODE *tempPtr, *nextPtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempPtr = (np+i*width+j)->Up_Car_Buffer;
            //
            //
            while(tempPtr != NULL){
                tempPtr->flag = 0;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Down_Car_Buffer;
            while(tempPtr != NULL){
                tempPtr->flag = 0;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Left_Car_Buffer;
            while(tempPtr != NULL){
                tempPtr->flag = 0;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            tempPtr = (np+i*width+j)->Right_Car_Buffer;
            while(tempPtr != NULL){
                tempPtr->flag = 0;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
        }
    }
}
void Refresh_Map(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length){
    int i,j;
    int x,y;
    int temp_ID;
    int Dis = -10;
    C_NODE *tempPtr,*prePtr, *Last_Vehicle;
    T_NODE *Last_Des;
    C_INFRASTRUCTURE *tempItr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            tempItr = ip+i*width+j;
            //Up
            tempPtr = tempItr->Up_Car_Buffer;
            Dis = -10;
            while(tempPtr != NULL){
                if(tempPtr->flag == 0){
                    tempPtr->flag = 1;
                    temp_ID = tempPtr->ID;
                    Last_Des = last_node(tempPtr->Path);
                    if(tempItr->Traffic_Light[0] == 0){ //Red light
                        if(Dis == -10){ // Red Light head vehicle
                            if((tempPtr->y + tempPtr->Speed) <= tempItr->y){
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                                Dis = tempPtr->y - tempPtr->Car_Length;
                                if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                    Dis = -10;
                                    tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                    tempPtr = tempPtr->nextCar;
                                    tempItr->Up_Car_Buffer = delete_node(tempItr->Up_Car_Buffer, temp_ID);
                                }
                                else{
                                    tempPtr = tempPtr->nextCar;
                                }
                            }
                            else{
                                tempPtr->y = tempItr->y;
                                Dis = tempPtr->y - tempPtr->Car_Length;
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                        else if(tempPtr->y + tempPtr->Speed <= Dis){ // Others can move
                            tempPtr->y = tempPtr->y + tempPtr->Speed;
                            Dis = tempPtr->y - tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                        else{ //Others can't move
                            tempPtr->y = Dis;
                            Dis = tempPtr->y - tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                    }
                    else{ //Green Light
                        tempPtr->Path = Trajectory_Change(tempPtr->Path,tempPtr->x,tempPtr->y);
                        if(tempPtr->Path == NULL){
                            tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                            tempPtr = tempPtr->nextCar;
                            tempItr->Up_Car_Buffer = delete_node(tempItr->Up_Car_Buffer, temp_ID);
                            break;
                        }
                        x = (tempPtr->Path->x)/Road_Length;
                        y = (tempPtr->Path->y)/Road_Length;
                        tempPtr->Direction = Check_Dir(tempPtr->Path, tempPtr->x, tempPtr->y);
                        if(tempItr->x != tempPtr->Path->x || tempItr->y != tempPtr->Path->y){ //Intersection vehicle not in Destination
                            prePtr = tempPtr->nextCar;
                            tempItr->Up_Car_Buffer = prePtr;
                            tempPtr->nextCar = NULL;
                            switch(tempPtr->Direction){
                            case 0:
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Up_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y >= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Up_Car_Buffer = insert_node((ip+y*width+x)->Up_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 1:
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Left_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x <= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x + Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Left_Car_Buffer = insert_node((ip+y*width+x)->Left_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 2:
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Right_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x >= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Right_Car_Buffer = insert_node((ip+y*width+x)->Right_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 3:
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Down_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y <= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Down_Car_Buffer = insert_node((ip+y*width+x)->Down_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            }
                        }
                        else{ // Other car
                            if((tempPtr->y + tempPtr->Speed) <= tempItr->y){
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                            }
                            else{
                                tempPtr->y = tempItr->y;
                            }
                            if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                tempPtr = tempPtr->nextCar;
                                tempItr->Up_Car_Buffer = delete_node(tempItr->Up_Car_Buffer, temp_ID);
                            }
                            else{
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                    }
                }
                else{
                    tempPtr = tempPtr->nextCar;
                }
            }
            //Left
            tempPtr =  tempItr->Left_Car_Buffer;
            Dis = -10;
            while(tempPtr != NULL){
                if(tempPtr->flag == 0){
                    tempPtr->flag = 1;
                    temp_ID = tempPtr->ID;
                    Last_Des = last_node(tempPtr->Path);
                    if(tempItr->Traffic_Light[1] == 0){
                        if(Dis == -10){
                            if((tempPtr->x - tempPtr->Speed) >= tempItr->x){
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                                Dis = tempPtr->x + tempPtr->Car_Length;
                                if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                    tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                    tempPtr = tempPtr->nextCar;
                                    Dis = -10;
                                    tempItr->Left_Car_Buffer = delete_node(tempItr->Left_Car_Buffer, temp_ID);
                                }
                                else{
                                    tempPtr = tempPtr->nextCar;
                                }
                            }
                            else{
                                tempPtr->x = tempItr->x;
                                Dis = tempPtr->x + tempPtr->Car_Length;
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                        else if(tempPtr->x - tempPtr->Speed >= Dis){
                            tempPtr->x = tempPtr->x - tempPtr->Speed;
                            Dis = tempPtr->x + tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                        else{
                            tempPtr->x = Dis;
                            Dis = tempPtr->x + tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                    }
                    else{
                        tempPtr->Path = Trajectory_Change(tempPtr->Path,tempPtr->x,tempPtr->y);
                        if(tempPtr->Path == NULL){
                            tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                            tempPtr = tempPtr->nextCar;
                            tempItr->Left_Car_Buffer = delete_node(tempItr->Left_Car_Buffer, temp_ID);
                            break;
                        }
                        x = (tempPtr->Path->x)/Road_Length;
                        y = (tempPtr->Path->y)/Road_Length;
                        tempPtr->Direction = Check_Dir(tempPtr->Path, tempPtr->x, tempPtr->y);
                        if(tempItr->x != tempPtr->Path->x || tempItr->y != tempPtr->Path->y){
                            prePtr = tempPtr->nextCar;
                            tempItr->Left_Car_Buffer = prePtr;
                            tempPtr->nextCar = NULL;
                            switch(tempPtr->Direction){
                            case 0:
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Up_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y >= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Up_Car_Buffer = insert_node((ip+y*width+x)->Up_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 1:
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Left_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x <= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x + Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Left_Car_Buffer = insert_node((ip+y*width+x)->Left_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 2:
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Right_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x >= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Right_Car_Buffer = insert_node((ip+y*width+x)->Right_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 3:
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Down_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y <= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Down_Car_Buffer = insert_node((ip+y*width+x)->Down_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            }
                        }
                        else{
                            if((tempPtr->x - tempPtr->Speed) >= tempItr->x){
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                            }
                            else{
                                tempPtr->x = tempItr->x;
                            }
                            if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                tempPtr = tempPtr->nextCar;
                                tempItr->Left_Car_Buffer = delete_node(tempItr->Left_Car_Buffer, temp_ID);
                            }
                            else{
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                    }
                }
                else{
                    tempPtr = tempPtr->nextCar;
                }
            }
            //Right
            tempPtr =  tempItr->Right_Car_Buffer;
            Dis = -10;
            while(tempPtr != NULL){
                if(tempPtr->flag == 0){
                    tempPtr->flag = 1;
                    temp_ID = tempPtr->ID;
                    Last_Des = last_node(tempPtr->Path);
                    if(tempItr->Traffic_Light[1] == 0){
                        if(Dis == -10){
                            if((tempPtr->x + tempPtr->Speed) <= tempItr->x){
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                                Dis = tempPtr->x - tempPtr->Car_Length;
                                if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                    tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                    tempPtr = tempPtr->nextCar;
                                    Dis = -10;
                                    tempItr->Right_Car_Buffer = delete_node(tempItr->Right_Car_Buffer, temp_ID);
                                }
                                else{
                                    tempPtr = tempPtr->nextCar;
                                }
                            }
                            else{
                                tempPtr->x = tempItr->x;
                                Dis = tempPtr->x - tempPtr->Car_Length;
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                        else if(tempPtr->x + tempPtr->Speed <= Dis){
                            tempPtr->x = tempPtr->x + tempPtr->Speed;
                            Dis = tempPtr->x - tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                        else{
                            tempPtr->x = Dis;
                            Dis = tempPtr->x - tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                    }
                    else{
                        tempPtr->Path = Trajectory_Change(tempPtr->Path,tempPtr->x,tempPtr->y);
                        if(tempPtr->Path == NULL){
                            tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                            tempPtr = tempPtr->nextCar;
                            tempItr->Right_Car_Buffer = delete_node(tempItr->Right_Car_Buffer, temp_ID);
                            break;
                        }
                        x = (tempPtr->Path->x)/Road_Length;
                        y = (tempPtr->Path->y)/Road_Length;
                        tempPtr->Direction = Check_Dir(tempPtr->Path, tempPtr->x, tempPtr->y);
                        if(tempItr->x != tempPtr->Path->x || tempItr->y != tempPtr->Path->y){
                            prePtr = tempPtr->nextCar;
                            tempItr->Right_Car_Buffer = prePtr;
                            tempPtr->nextCar = NULL;
                            switch(tempPtr->Direction){
                            case 0:
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Up_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y >= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Up_Car_Buffer = insert_node((ip+y*width+x)->Up_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 1:
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Left_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x <= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x + Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Left_Car_Buffer = insert_node((ip+y*width+x)->Left_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 2:
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Right_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x >= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Right_Car_Buffer = insert_node((ip+y*width+x)->Right_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 3:
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Down_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y <= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Down_Car_Buffer = insert_node((ip+y*width+x)->Down_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            }
                        }
                        else{
                            if((tempPtr->x + tempPtr->Speed) <= tempItr->x){
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                            }
                            else{
                                tempPtr->x = tempItr->x;
                            }
                            if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                tempPtr->NextPacket = clear_node(tempPtr->NextPacket);
                                tempPtr = tempPtr->nextCar;
                                tempItr->Right_Car_Buffer = delete_node(tempItr->Right_Car_Buffer, temp_ID);
                            }
                            else{
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                    }
                }
                else{
                    tempPtr = tempPtr->nextCar;
                }
            }
            //Down
            tempPtr =  tempItr->Down_Car_Buffer;
            Dis = -10;
            while(tempPtr != NULL){
                if(tempPtr->flag == 0){
                    tempPtr->flag = 1;
                    temp_ID = tempPtr->ID;
                    Last_Des = last_node(tempPtr->Path);
                    if(tempItr->Traffic_Light[0] == 0){
                        if(Dis == -10){
                            if((tempPtr->y -tempPtr->Speed) >= tempItr->y){
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                                Dis = tempPtr->y + tempPtr->Car_Length;
                                if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                    tempPtr = tempPtr->nextCar;
                                    Dis = -10;
                                    tempItr->Down_Car_Buffer = delete_node(tempItr->Down_Car_Buffer, temp_ID);
                                }
                                else{
                                    tempPtr = tempPtr->nextCar;
                                }
                            }
                            else{
                                tempPtr->y = tempItr->y;
                                Dis = tempPtr->y + tempPtr->Car_Length;
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                        else if(tempPtr->y - tempPtr->Speed >= Dis){
                            tempPtr->y = tempPtr->y - tempPtr->Speed;
                            Dis = tempPtr->y + tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                        else{
                            tempPtr->y = Dis;
                            Dis = tempPtr->y + tempPtr->Car_Length;
                            tempPtr = tempPtr->nextCar;
                        }
                    }
                    else{
                        tempPtr->Path = Trajectory_Change(tempPtr->Path,tempPtr->x,tempPtr->y);
                        if(tempPtr->Path == NULL){
                            tempPtr = tempPtr->nextCar;
                            tempItr->Down_Car_Buffer = delete_node(tempItr->Down_Car_Buffer, temp_ID);
                            break;
                        }
                        x = (tempPtr->Path->x)/Road_Length;
                        y = (tempPtr->Path->y)/Road_Length;
                        tempPtr->Direction = Check_Dir(tempPtr->Path, tempPtr->x, tempPtr->y);
                        if(tempItr->x != tempPtr->Path->x || tempItr->y != tempPtr->Path->y){
                            prePtr = tempPtr->nextCar;
                            tempItr->Down_Car_Buffer = prePtr;
                            tempPtr->nextCar = NULL;
                            switch(tempPtr->Direction){
                            case 0:
                                tempPtr->y = tempPtr->y + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Up_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y >= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Up_Car_Buffer = insert_node((ip+y*width+x)->Up_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 1:
                                tempPtr->x = tempPtr->x - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Left_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x <= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x + Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Left_Car_Buffer = insert_node((ip+y*width+x)->Left_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 2:
                                tempPtr->x = tempPtr->x + tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Right_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->x >= Last_Vehicle->x)
                                        tempPtr->x = Last_Vehicle->x - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Right_Car_Buffer = insert_node((ip+y*width+x)->Right_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            case 3:
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                                Last_Vehicle = last_node((ip+y*width+x)->Down_Car_Buffer);
                                if(Last_Vehicle == NULL){}
                                else{
                                    if(tempPtr->y <= Last_Vehicle->y)
                                        tempPtr->y = Last_Vehicle->y - Last_Vehicle->Car_Length;
                                }
                                (ip+y*width+x)->Down_Car_Buffer = insert_node((ip+y*width+x)->Down_Car_Buffer, tempPtr);
                                tempPtr = prePtr;
                                break;
                            }
                        }
                        else{
                            if((tempPtr->y - tempPtr->Speed) >= tempItr->y){
                                tempPtr->y = tempPtr->y - tempPtr->Speed;
                            }
                            else{
                                tempPtr->y = tempItr->y;
                            }
                            if(tempPtr->x == Last_Des->x && tempPtr->y == Last_Des->y){
                                tempPtr = tempPtr->nextCar;
                                tempItr->Down_Car_Buffer = delete_node(tempItr->Down_Car_Buffer, temp_ID);
                            }
                            else{
                                tempPtr = tempPtr->nextCar;
                            }
                        }
                    } // else (Green)
                } // If flag
                else{
                    tempPtr = tempPtr->nextCar;
                }
            } // while
        } // for
    } //for
} //function
void DisPlay_All_Car(C_INFRASTRUCTURE *np, int height, int width, int T){
    char filename[]="All_Car_LOCATION.txt";
    fstream fp;
    fp.open(filename, ios::out);
    fp << "ALL_CAR_LOCATION" << endl;
    fp << "~~~~~~~TIME = " << T << endl;
    int i,j;
    C_NODE *tempPtr, *nextPtr;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            fp << "==============  At Intersection  ============== " << (np+i*width+j)->x <<  " , " << (np+i*width+j)->y << endl;
            fp << "Up Direction : " << endl;
            tempPtr = (np+i*width+j)->Up_Car_Buffer;
            while(tempPtr != NULL){
                fp << "Car ID : " << tempPtr->ID;
                fp << " ----  Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            fp << "Down Direction : " << endl;
            tempPtr = (np+i*width+j)->Down_Car_Buffer;
            while(tempPtr != NULL){
                fp << "Car ID : " << tempPtr->ID;
                fp << " ----  Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            fp << "Left Direction : " << endl;
            tempPtr = (np+i*width+j)->Left_Car_Buffer;
            while(tempPtr != NULL){
                fp << "Car ID : " << tempPtr->ID;
                fp << " ----  Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
            fp << "Right Direction : " << endl;
            tempPtr = (np+i*width+j)->Right_Car_Buffer;
            while(tempPtr != NULL){
                fp << "Car ID : " << tempPtr->ID;
                fp << " ----  Location : " << tempPtr->x << " , " << tempPtr->y << endl;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(nextPtr == NULL)break;
            }
        }
    }
}
int Search_Empty(C_INFRASTRUCTURE *np, int Dir){
    int x,y;
    x = np->x;
    y = np->y;
    C_NODE *tempPtr, *nextPtr;
    switch(Dir){
    case 0 :
        tempPtr = np->Up_Car_Buffer;
        if(tempPtr == NULL)return y;
        else{
            while(y <= tempPtr->y){
                y -= 3;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(tempPtr == NULL)break;
            }
        }
        return y;
        break;
    case 1 :
        tempPtr = np->Left_Car_Buffer;
        if(tempPtr == NULL)return x;
        else{
            while(x >= tempPtr->x){
                x += 3;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(tempPtr == NULL)break;
            }
        }
        return x;
        break;
    case 2 :
        tempPtr = np->Right_Car_Buffer;
        if(tempPtr == NULL)return x;
        else{
            while(x <= tempPtr->x){
                x -= 3;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(tempPtr == NULL)break;
            }
        }
        return x;
        break;
    case 3 :
        tempPtr = np->Down_Car_Buffer;
        if(tempPtr == NULL)return y;
        else{
            while(y >= tempPtr->y){
                y += 3;
                nextPtr = tempPtr->nextCar;
                tempPtr = nextPtr;
                if(tempPtr == NULL)break;
            }
        }
        return y;
        break;
    }
    return 0;
}
void Create_Car(C_INFRASTRUCTURE *np, int height, int width,int Road_Length, int Speed, int Car_Length){
    static int ID = 0;
    int cox,coy,Space;
    C_NODE *tempPtr;
    tempPtr = (C_NODE *)malloc(sizeof(C_NODE));
    tempPtr->Path = Random_Create_Path(height,width,Road_Length);
    coy = (tempPtr->Path->x)/Road_Length;
    cox = (tempPtr->Path->y)/Road_Length;
    tempPtr->x = tempPtr->Path->x;
    tempPtr->y = tempPtr->Path->y;
    tempPtr->Path = Trajectory_Change(tempPtr->Path, tempPtr->x, tempPtr->y);
    tempPtr->Direction = Check_Dir(tempPtr->Path, tempPtr->x, tempPtr->y);
    tempPtr->brake = 3;
    tempPtr->ID = ID;
    tempPtr->Car_Length = Car_Length;
    tempPtr->Speed = Speed;
    tempPtr->flag = 0;
    tempPtr->NextPacket = NULL;
    switch(tempPtr->Direction){
        case 0:
            Space = Search_Empty((np+cox*width+coy),tempPtr->Direction);
            tempPtr->y = Space;
            (np+cox*width+coy)->Up_Car_Buffer = insert_node((np+cox*width+coy)->Up_Car_Buffer, tempPtr);
            break;
        case 1:
            Space = Search_Empty((np+cox*width+coy),tempPtr->Direction);
            tempPtr->x = Space;
            (np+cox*width+coy)->Left_Car_Buffer = insert_node((np+cox*width+coy)->Left_Car_Buffer, tempPtr);
            break;
        case 2:
            Space = Search_Empty((np+cox*width+coy),tempPtr->Direction);
            tempPtr->x = Space;
            (np+cox*width+coy)->Right_Car_Buffer = insert_node((np+cox*width+coy)->Right_Car_Buffer , tempPtr);
            break;
        case 3:
            Space = Search_Empty((np+cox*width+coy),tempPtr->Direction);
            tempPtr->y = Space;
            (np+cox*width+coy)->Down_Car_Buffer = insert_node((np+cox*width+coy)->Down_Car_Buffer, tempPtr);
            break;
        default:
            break;
    }
    ID++;
}
void Ini_Map(C_INFRASTRUCTURE *np,int height, int width, int Road_Length){
    int i,j;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            (np+i*width+j)->Down_Car_Buffer = NULL;
            (np+i*width+j)->Left_Car_Buffer = NULL;
            (np+i*width+j)->Right_Car_Buffer = NULL;
            (np+i*width+j)->Up_Car_Buffer = NULL;
            (np+i*width+j)->x = j*Road_Length;
            (np+i*width+j)->y = i*Road_Length;
            (np+i*width+j)->PACKET_BUFFER = NULL;
            (np+i*width+j)->Transmission_Range = 100;
        }
    }
}
void Random_Traffic_Light(C_INFRASTRUCTURE *np, int height, int width){ // 0 : up, down ; 1 : left, right
    int i,j;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            int Traffic = rand()%2;
            switch(Traffic){
            case 0 :
                (np+i*width+j)->Traffic_Light[0] = 0;
                (np+i*width+j)->Traffic_Light[1] = 1;
                break;
            case 1 :
                (np+i*width+j)->Traffic_Light[0] = 1;
                (np+i*width+j)->Traffic_Light[1] = 0;
                break;
            }
        }
    }
}
void Traffic_Light_Change(C_INFRASTRUCTURE *np, int height, int width){
    int i,j;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
            switch((np+i*width+j)->Traffic_Light[0]){
            case 0 :
                (np+i*width+j)->Traffic_Light[0] = 1;
                (np+i*width+j)->Traffic_Light[1] = 0;
                break;
            case 1 :
                (np+i*width+j)->Traffic_Light[0] = 0;
                (np+i*width+j)->Traffic_Light[1] = 1;
                break;
            }
        }
    }
}
void Show_Light(C_INFRASTRUCTURE *np, int height, int width, int time){
    int i,j;
    char filename[]="Traffic_Light_Map.txt";
    fstream fp;
    fp.open(filename, ios::out|ios::app);
    fp << "Traffic Light Scenario" << endl;
    fp << "At Time " << time <<" 1/5 Sec" << endl << endl;
    fp << "Vertical Traffic Light : " << endl;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
                if((np+i*width+j)->Traffic_Light[0] == 0){
                    fp << " X";
                }
                else{
                    fp << " O";
                }
        }
        fp << endl;
    }
    fp << endl;
    fp << "Horizontal Traffic Light : " << endl;
    for(i=0;i<height;i++){
        for(j=0;j<width;j++){
                if((np+i*width+j)->Traffic_Light[1] == 0){
                    fp << " X";
                }
                else{
                    fp << " O";
                }
        }
        fp << endl;
    }
}
