#include <iostream>
#include <cstdlib>

#ifndef INFRASTRUCTURE_H_
#define INFRASTRUCTURE_H_

#include "Car.h"
#include "Packet.h"

typedef struct c_infrastructure {
    int x;
    int y;
    int Traffic_Light[2];
    int Transmission_Range;
    C_NODE *Up_Car_Buffer;
    C_NODE *Left_Car_Buffer;
    C_NODE *Right_Car_Buffer;
    C_NODE *Down_Car_Buffer;
    C_PACKET *PACKET_BUFFER;
}C_INFRASTRUCTURE;

void Display_All_Vehicles_Trajectory(C_INFRASTRUCTURE *np, int height, int width);
int CAR_AMOUNT(C_INFRASTRUCTURE *np, int height, int width);
void DisPlay_All_Car_With_ID(C_INFRASTRUCTURE *np, int height, int width, int T, int Traffic_Light_Period);
void Set_Vehicle_Flag(C_INFRASTRUCTURE *ip, int height, int width);
void Traffic_Light_Change(C_INFRASTRUCTURE *np, int height, int width);
void Refresh_Map(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length);
void DisPlay_All_Car(C_INFRASTRUCTURE *ip, int height, int width, int T);
int Search_Empty(C_INFRASTRUCTURE *np, int Dir);
void Create_Car(C_INFRASTRUCTURE *ip, int height, int width,int Road_Length, int Speed, int Car_Length);
void Random_Traffic_Light(C_INFRASTRUCTURE *np, int height, int width);
void Show_Light(C_INFRASTRUCTURE *np, int height, int width, int time);
void Ini_Map(C_INFRASTRUCTURE *np,int height, int width, int Road_Length);

C_PACKET *Routing_Scheme1(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car); // All Send
C_PACKET *Routing_Scheme2(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car); // Markov Send
C_PACKET *Routing_Scheme3(C_INFRASTRUCTURE *ip, C_PACKET *Packet, C_NODE *Car); // Chernoff Send
int Set_Car_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length, int Success);
void Set_Infrastructure_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length);
void Refresh_Infrastructure_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length);
void Refresh_Car_Packet(C_INFRASTRUCTURE *ip, int height, int width, int Road_Length);
void Create_Packet(C_INFRASTRUCTURE *ip, int Road_Length, int TTL, int bytes, int Height, int Width, int Speed);
int Check_Path(T_NODE *np, int Des_x, int Des_y);
void DisPlay_All_Packet(C_INFRASTRUCTURE *ip, int height, int width);

#endif
